//+---------------------------------------------------------------------+
//|                                                     TTF_Plus_MW.mq5 |
//|                                            Copyright  2007, MojoFX |
//|                                            http://fx.studiomojo.com |
//+---------------------------------------------------------------------+ 
//|     SmoothAlgorithms.mqh      |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
//---  
#property copyright "Copyright  2007, MojoFX"
//---    
#property link "http://fx.studiomojo.com"
//---   
#property version   "1.00"
//---     
#property indicator_chart_window
//---        
#property indicator_buffers 2
//---    
#property indicator_plots   2
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//---   1   
#property indicator_type1   DRAW_ARROW
//---       Blue 
#property indicator_color1  clrBlue
//---    1  2
#property indicator_width1  2
//---    
#property indicator_label1  "Upper TTF_Plus_MW"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//---   2   
#property indicator_type2   DRAW_ARROW
//---        MediumVioletRed
#property indicator_color2  clrMediumVioletRed
//---    2  2
#property indicator_width2  2
//---    
#property indicator_label2  "Lower TTF_Plus_MW"
//+----------------------------------------------+
//|    CXMA                        |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+
//---    CXMA   SmoothAlgorithms.mqh
CXMA XMA1;
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint   TTFbars=6;                 //   
input Smooth_Method XMA_Method=MODE_T3; //  
input uint XLength=12;                  //                      
input int XPhase=15;                    //  
//--- XPhase:  JJMA    -100 ... +100,     ;
//--- XPhase:  VIDIA   CMO,  AMA    
input int    Shift=0;                   //      
//+----------------------------------------------+
//---   ,   
//---      
double ExtMapBufferUp[];
double ExtMapBufferDown[];
//---      
int ATR_Handle;
//---      
int min_rates_total,min_rates_;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
int OnInit()
  {
//---    ATR
   int ATRPeriod=15;
   ATR_Handle=iATR(NULL,0,ATRPeriod);
   if(ATR_Handle==INVALID_HANDLE)
     {
      Print("      ATR");
      return(INIT_FAILED);
     }
//---     
   min_rates_=int(TTFbars+1);
   min_rates_total=int(MathMax(XMA1.GetStartBars(XMA_Method,XLength,XPhase)+min_rates_,ATRPeriod));
//---    ExtMapBufferUp[]   
   SetIndexBuffer(0,ExtMapBufferUp,INDICATOR_DATA);
//---    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(ExtMapBufferUp,true);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---    ExtMapBufferDown[]   
   SetIndexBuffer(1,ExtMapBufferDown,INDICATOR_DATA);
//---    2    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//---       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(ExtMapBufferDown,true);
//---   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      
   string shortname;
   string Smooth=XMA1.GetString_MA_Method(XMA_Method);
   StringConcatenate(shortname,"TTF_Plus_MW(",TTFbars,", ",Smooth,", ",XLength,XPhase,", ",Shift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(BarsCalculated(ATR_Handle)<rates_total
      || rates_total<min_rates_total)
      return(RESET);
//---    
   double ATR[],HighestHighRecent,HighestHighOlder;
   double LowestLowRecent,LowestLowOlder,BuyPower,SellPower,res,TTF;
   int limit,to_copy,bar,maxbar;
//---    ,     
   ArraySetAsSeries(close,true);
   ArraySetAsSeries(ATR,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      limit=rates_total-min_rates_-1;               //      
     }
   else
     {
      limit=rates_total-prev_calculated;            //      
     }
   maxbar=rates_total-min_rates_-1;
   to_copy=limit+1;
//---      
   if(CopyBuffer(ATR_Handle,0,0,to_copy,ATR)<=0) return(RESET);
//---    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      ExtMapBufferUp[bar]=EMPTY_VALUE;
      ExtMapBufferDown[bar]=EMPTY_VALUE;
      HighestHighRecent=high[ArrayMaximum(high,bar+TTFbars+1,TTFbars)];
      HighestHighOlder=high[ArrayMaximum(high,bar+1,TTFbars)];
      LowestLowRecent=low[ArrayMinimum(low,bar+TTFbars+1,TTFbars)];
      LowestLowOlder=low[ArrayMinimum(low,bar+1,TTFbars)];
      BuyPower=HighestHighRecent-LowestLowOlder;
      SellPower=HighestHighOlder -LowestLowRecent;
      res=0.5*(BuyPower+SellPower);
      if(res) TTF=100*(BuyPower-SellPower)/res;
      else TTF=EMPTY_VALUE;
      TTF=XMA1.XMASeries(maxbar,prev_calculated,rates_total,XMA_Method,XPhase,XLength,TTF,bar,true);
      if(TTF<=-100) ExtMapBufferDown[bar]=high[bar]+ATR[bar]*3/8;
      if(TTF>=+100) ExtMapBufferUp[bar]=low[bar]-ATR[bar]*3/8;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
